/**********************************************************************
 *<
	FILE: PainterTextureSample.cpp

	DESCRIPTION:	Appwizard generated plugin

	CREATED BY: 

	HISTORY: 


	check if view res changed and if so readjust
	stroke ending off the canvas get canceled
	fix the str to be multiple by the str field
	fix the size to be multiple by the size field
	paint only on selected faces
	alt color picker
	blender/smoother



 *>	Copyright (c) 2000, All Rights Reserved.
 **********************************************************************/

#include "PainterTextureSample.h"




static PainterTextureSampleClassDesc PainterTextureSampleDesc;
ClassDesc2* GetPainterTextureSampleDesc() { return &PainterTextureSampleDesc; }



static ParamBlockDesc2 paintertexturesample_param_blk ( PainterTextureSample::paintertexturesample_params, _T("params"),  0, &PainterTextureSampleDesc, 
	P_AUTO_CONSTRUCT + P_AUTO_UI+ P_MULTIMAP, 1, 
	3,
	//rollout
	PainterTextureSample::paintertexturesample_bitmap,IDD_BITMAPPANEL, IDS_PARAMS, 0, 0, NULL,
	PainterTextureSample::paintertexturesample_paint,IDD_PANEL, IDS_PARAMS, 0, 0, NULL,
	PainterTextureSample::paintertexturesample_advance,IDD_PANEL1, IDS_ADVANCEPARAMS, 0, 0, NULL,
	// params

	PainterTextureSample::pb_bitmap, _T("bitmap"),	TYPE_BITMAP, 0, IDS_PW_BITMAP,
		p_ui,			PainterTextureSample::paintertexturesample_bitmap, TYPE_BITMAPBUTTON, IDC_BITMAP,
		end,

	PainterTextureSample::pb_color,	 _T("color"),	TYPE_RGBA,				0,	IDS_PW_COLOR,	
		p_default,		Color(0,0,0), 
		p_ui,			PainterTextureSample::paintertexturesample_paint,TYPE_COLORSWATCH, IDC_COLOR, 
		end,


	PainterTextureSample::pb_stroketype,	_T("strokeType"),	TYPE_INT,	0,	IDS_PW_STROKETYPE,
	// optional tagged param specs
		p_default,		kPen,
		p_ui,			PainterTextureSample::paintertexturesample_paint,TYPE_INTLISTBOX, IDC_INKS_COMBO, 4,
						IDS_PW_PEN, IDS_PW_LINE, IDS_PW_RECTANGLE,IDS_PW_CIRCLE,
		p_vals,			kPen, kLine, kRectangle,kCircle,
		end,


	PainterTextureSample::pb_coords,			_T("coords"),		TYPE_REFTARG,	P_OWNERS_REF,	IDS_COORDS,
		p_refno,		COORD_REF, 
		end,

	PainterTextureSample::pb_samplerate,	_T("sampleRate"),	TYPE_INT,	P_RESET_DEFAULT,	IDS_PW_SAMPLERATE,
		p_default,		5,
		p_range, 		0, 100, 
		p_ui,			PainterTextureSample::paintertexturesample_paint,TYPE_SPINNER, EDITTYPE_INT, IDC_SAMPLERATE, IDC_SAMPLERATESPINNER, 0.5f,
		end,

	PainterTextureSample::pb_gradient,	_T("gradient"),	TYPE_INT,	0,	IDS_PW_GRADIENT,
	// optional tagged param specs
		p_default,		kNoGradient,
		p_ui,			PainterTextureSample::paintertexturesample_paint,TYPE_INTLISTBOX, IDC_GRADIENT_COMBO, 4,
						IDS_PW_NOGRADIENT, IDS_PW_UGRADIENT, IDS_PW_VGRADIENT,IDS_PW_UVGRADIENT,
		p_vals,			kNoGradient, kUGradient, kVGradient,kUVGradient,
		end,

	PainterTextureSample::pb_gradienttex, 	_T("gradientTexture"),		TYPE_TEXMAP, 		0,				IDS_PW_TEXMAP,
		p_ui, 			PainterTextureSample::paintertexturesample_paint,TYPE_TEXMAPBUTTON, 	IDC_GRADIENT, 
		p_subtexno,		0,
		p_refno,		2, 
		end, 

	PainterTextureSample::pb_spline, 	_T("node"),		TYPE_INODE, 		0,				IDS_PW_NODE,
		p_ui, 			PainterTextureSample::paintertexturesample_paint,TYPE_PICKNODEBUTTON, 	IDC_SPLINE, 
		end, 

	PainterTextureSample::pb_manualupdate, 	_T("manualUpdate"),		TYPE_BOOL, 		0,				IDS_PW_MANUALUPDATE,
		p_default,		FALSE,
		p_ui, 			PainterTextureSample::paintertexturesample_bitmap,TYPE_SINGLECHEKBOX, 	IDC_MANUALUPDATECHECK, 
		end, 

	PainterTextureSample::pb_overscan,	_T("overScan"),	TYPE_INT,	P_RESET_DEFAULT,	IDS_PW_OVERSCAN,
		p_default,		0,
		p_range, 		0, 10, 
		p_ui,			PainterTextureSample::paintertexturesample_advance,TYPE_SPINNER, EDITTYPE_INT, IDC_OVERSCAN, IDC_OVERSCANSPINNER, 0.5f,
		end,

	end
	);



ParamDlg* PainterTextureSample::uvGenDlg;



BOOL PainterTextureDlgProc::DlgProc(
		TimeValue t,IParamMap2 *map,
		HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
	
	switch (msg) 
		{	

		case WM_INITDIALOG:
			{
//			tex->painterHwnd = hWnd;
			break;
			}
		case WM_COMMAND:
			{
			switch (LOWORD(wParam)) 
				{

				case IDC_VIEW:
					tex->ShowMap();
					break;

				case IDC_UPDATE:
					tex->UpdateMap();
					break;

				case IDC_SAVE:
					tex->SaveMap();
					break;

				}
			break;
			}
		}

	return FALSE;
	
}

//--- PainterTextureSample -------------------------------------------------------
PainterTextureSample::PainterTextureSample()
{
	for (int i=0; i<NSUBTEX; i++) subtex[i] = NULL;
	//TODO: Add all the initializing stuff
	pblock = NULL;
	PainterTextureSampleDesc.MakeAutoParamBlocks(this);
	uvGen = NULL;

	pPainter = NULL;
	texHandle = NULL;
	Reset();
	bm = NULL;
	width = 0;
	hiresBitmapPB = NULL;
//	hirereTheBM = NULL;

	hiresWidth = 0;
	hiresHeight = 0;
	painterProc = NULL;
	node = NULL;


}

PainterTextureSample::~PainterTextureSample()
{

	DiscardTexHandle();
}

//From MtlBase
void PainterTextureSample::Reset() 
{
	if (uvGen) uvGen->Reset();
	else ReplaceReference( 0, GetNewDefaultUVGen());	
	//TODO: Reset texmap back to its default values

	ivalid.SetEmpty();

}

void PainterTextureSample::Update(TimeValue t, Interval& valid) 
{	
	//TODO: Add code to evaluate anything prior to rendering
	pblock->GetValue( pb_bitmap, 0,hiresBitmapPB, FOREVER );
	if (hiresBitmapPB)
		{
		if (hiresBitmapPB->bm == NULL)
			{
			hiresBitmapPB->Load();
			}

		}
}

Interval PainterTextureSample::Validity(TimeValue t)
{
	//TODO: Update ivalid here
	return ivalid;
}

ParamDlg* PainterTextureSample::CreateParamDlg(HWND hwMtlEdit, IMtlParams *imp) 
{
	IAutoMParamDlg* masterDlg = PainterTextureSampleDesc.CreateParamDlgs(hwMtlEdit, imp, this);
	uvGenDlg = uvGen->CreateParamDlg(hwMtlEdit, imp);
	masterDlg->AddDlg(uvGenDlg);

	painterProc = new PainterDlgProc(this);
	paintertexturesample_param_blk.SetUserDlgProc(PainterTextureSample::paintertexturesample_paint, painterProc);
	paintertexturesample_param_blk.SetUserDlgProc(PainterTextureSample::paintertexturesample_bitmap, new PainterTextureDlgProc(this));

	//TODO: Set the user dialog proc of the param block, and do other initialization	


	return masterDlg;	
}

BOOL PainterTextureSample::SetDlgThing(ParamDlg* dlg)
{	
	if (dlg == uvGenDlg)
		uvGenDlg->SetThing(uvGen);
	else 
		return FALSE;
	return TRUE;
}

void PainterTextureSample::SetSubTexmap(int i, Texmap *m) 
{
	ReplaceReference(i+2,m);
	//TODO Store the 'i-th' sub-texmap managed by the texture
}

TSTR PainterTextureSample::GetSubTexmapSlotName(int i) 
{	
	//TODO: Return the slot name of the 'i-th' sub-texmap
	return TSTR(_T("Gradient Texture"));
}


//From ReferenceMaker
RefTargetHandle PainterTextureSample::GetReference(int i) 
{
	//TODO: Return the references based on the index	
	switch (i) {
		case 0: return uvGen;
		case 1: return pblock;
		default: return subtex[i-2];
		}
}

void PainterTextureSample::SetReference(int i, RefTargetHandle rtarg) 
{
	//TODO: Store the reference handle passed into its 'i-th' reference
	switch(i) {
		case 0: uvGen = (UVGen *)rtarg; break;
		case 1:	pblock = (IParamBlock2 *)rtarg; break;
		default: subtex[i-2] = (Texmap *)rtarg; break;
	}
}

//From ReferenceTarget 
RefTargetHandle PainterTextureSample::Clone(RemapDir &remap) 
{
	PainterTextureSample *mnew = new PainterTextureSample();
	*((MtlBase*)mnew) = *((MtlBase*)this); // copy superclass stuff
	//TODO: Add other cloning stuff
	BaseClone(this, mnew, remap);
	return (RefTargetHandle)mnew;
}

	 
Animatable* PainterTextureSample::SubAnim(int i) 
{
	//TODO: Return 'i-th' sub-anim
	switch (i) {
		case 0: return uvGen;
		case 1: return pblock;
		default: return subtex[i-2];
		}
}

TSTR PainterTextureSample::SubAnimName(int i) 
{
	//TODO: Return the sub-anim names
	switch (i) {
		case 0: return GetString(IDS_COORDS);		
		case 1: return GetString(IDS_PARAMS);
		default: return GetSubTexmapTVName(i-2);
		}
}

RefResult PainterTextureSample::NotifyRefChanged(Interval changeInt, RefTargetHandle hTarget, 
   PartID& partID, RefMessage message ) 
{
	//TODO: Handle the reference changed messages here	
	//TODO: Add code to handle the various reference changed messages
	switch (message) 
		{
		case REFMSG_CHANGE:
			if (hTarget == pblock)
				{
				ParamID changing_param = pblock->LastNotifyParamID();

				paintertexturesample_param_blk.InvalidateUI(changing_param);
				}
			break;

				
		}
	return REF_SUCCEED;
}

IOResult PainterTextureSample::Save(ISave *isave) 
{
	//TODO: Add code to allow plugin to save its data
	return IO_OK;
}

IOResult PainterTextureSample::Load(ILoad *iload) 
{ 
	//TODO: Add code to allow plugin to load its data
	return IO_OK;
}


AColor PainterTextureSample::Sample(ShadeContext& sc, float u,float v) 
{
	BMM_Color_fl c;
	int x,y;
	float fu,fv;
	fu = frac(u);
	fv = 1.0f-frac(v);

	x = (int)(fu*hiresWidth);
	y = (int)(fv*hiresHeight);

	 
	if ((hiresBitmapPB)&& (hiresBitmapPB->bm)) hiresBitmapPB->bm->GetLinearPixels(x,y,1,&c);

	return c;
}



AColor PainterTextureSample::EvalColor(ShadeContext& sc)
{
	//TODO: Evaluate the color of texture map for the context.

	Point3 uvw = sc.UVW(1);
	return Sample(sc,uvw.x,uvw.y) ;
}

float PainterTextureSample::EvalMono(ShadeContext& sc)
{
	//TODO: Evaluate the map for a "mono" channel

	Point3 uvw = sc.UVW(1);
	
	return Intens(Sample(sc,uvw.x,uvw.y) );
}

Point3 PainterTextureSample::EvalNormalPerturb(ShadeContext& sc)
{
	//TODO: Return the perturbation to apply to a normal for bump mapping
	return Point3(0, 0, 0);
}

ULONG PainterTextureSample::LocalRequirements(int subMtlNum)
{
//	return MTLREQ_UV;
	//TODO: Specify various requirements for the material
	return uvGen->Requirements(subMtlNum); 
}

void PainterTextureSample::DiscardTexHandle() 
	{
	if (texHandle) 
		{
		texHandle->DeleteThis();
		texHandle = NULL;
		}
	}

void PainterTextureSample::ActivateTexDisplay(BOOL onoff)
{
	if (!onoff) 
		DiscardTexHandle();
}

BITMAPINFO* PainterTextureSample::GetVPDisplayDIB(TimeValue t, TexHandleMaker& thmaker, Interval &valid, BOOL mono, BOOL forceW, BOOL forceH) 
	{
//	Bitmap *bm;
	Interval v;
	Update(t,v);
	int size = thmaker.Size();

	Point3 color;
	pblock->GetValue( pb_color, 0, color, FOREVER);

	pblock->GetValue( pb_bitmap, 0,hiresBitmapPB, FOREVER );
	if ( (hiresBitmapPB) && (hiresBitmapPB->bm != NULL) )
		{
		hiresWidth = hiresBitmapPB->bi.Width();
		hiresHeight = hiresBitmapPB->bi.Height();
		}

	width = size;
	bm = BuildBitmap(size);
	
	BITMAPINFO *bmi = thmaker.BitmapToDIB(bm,0,0,forceW,forceH);


	valid.SetInfinite();

	return bmi;
	}


DWORD PainterTextureSample::GetActiveTexHandle(TimeValue t, TexHandleMaker& thmaker)
	{
	if (texHandle) 
		{
		if (texHandleValid.InInterval(t))
			return texHandle->GetHandle();
		else DiscardTexHandle();
		}
	texHandle = thmaker.MakeHandle(GetVPDisplayDIB(t,thmaker,texHandleValid));
	return texHandle->GetHandle();
	}

inline UWORD FlToWord(float r) {
	return (UWORD)(65535.0f*r);
	}

Bitmap *PainterTextureSample::BuildBitmap(int size) 
	{
	float u,v;
	BitmapInfo bi;
	bi.SetName(_T("painterTemp"));
	bi.SetWidth(size);
	bi.SetHeight(size);
	bi.SetType(BMM_TRUE_64);

	lowresBi = bi;

	pblock->GetValue( pb_bitmap, 0,hiresBitmapPB, FOREVER );
	if ( (bm == NULL) && (hiresBitmapPB))
		{
		bm = TheManager->Create(&bi);
		holdbm = TheManager->Create(&bi);
		if (bm==NULL) return NULL;
		if (holdbm==NULL) return NULL;

		if (hiresBitmapPB->bm != NULL)
			{
			holdbm->CopyImage(hiresBitmapPB->bm,COPY_IMAGE_RESIZE_HI_QUALITY,0);
			bm->CopyImage(hiresBitmapPB->bm,COPY_IMAGE_RESIZE_HI_QUALITY,0);
			hiresWidth = hiresBitmapPB->bi.Width();
			hiresHeight = hiresBitmapPB->bi.Height();
			}
		else
			{
			PixelBuf l64(size);
			float d = 1.0f/float(size);
			v = 1.0f - 0.5f*d;
			for (int y=0; y<size; y++) 
				{
				BMM_Color_64 *p64=l64.Ptr();
				u = 0.0f;
				for (int x=0; x<size; x++, p64++) 
					{
					AColor c(0.0f,0.0f,0.0f) ;
					p64->r = FlToWord(c.r); 
					p64->g = FlToWord(c.g); 
					p64->b = FlToWord(c.b);
					p64->a = 0xffff; 
					u += d;
					}
				bm->PutPixels(0,y, size, l64.Ptr()); 
				v -= d;
				}
			}

		
		}
	width = size;
	return bm;
	}





#define EPSILON 0.000001f
//This thing is ugly should really do scan conversion instead of barycentric
void  PainterTextureSample::BuildWorldSpaceData(Mesh *msh, Matrix3 tm,
												int width, int height,
												Tab<Point3> &worldSpaceList,
												Tab<int> &uvwList,
												int whichText
												)
{
//loop through each face
	Tab<Point3> tempWorldPointList;

	tempWorldPointList.SetCount(msh->numVerts);
	for (int i = 0; i < msh->numVerts; i++)
		{
		tempWorldPointList[i] = msh->verts[i] * tm;
		}

	worldSpaceList.ZeroCount();
	uvwList.ZeroCount();

//process face interiors
	BitArray processedCells;

	processedCells.SetSize(width*height);
	processedCells.ClearAll();
	HWND textHWND;
	if (whichText == 0)
		textHWND = GetDlgItem(painterHwnd,IDC_TEXT);
	else textHWND = GetDlgItem(painterHwnd,IDC_TEXT2);

	float halfU, halfV;
	float incU, incV;

/*
	for (int y =0; y < height; y++)
		{
		u = halfU;	
		TSTR name;
		name.printf("Processing Face %d/%d",y,height);
		SetWindowText(textHWND,name);

		for (int x =0; x < width; x++)
			{
//loop through all faces
//check center
			for (int i =0; i < msh->numFaces; i++)
				{
		
//gets its world space position corners
				Point3 t[3];
				Point3 w[3];
		

				w[0] = tempWorldPointList[msh->faces[i].v[0]];
				w[1] = tempWorldPointList[msh->faces[i].v[1]];
				w[2] = tempWorldPointList[msh->faces[i].v[2]];


				t[0] = uvwPoints[uvwFaces[i].t[0]];
				t[1] = uvwPoints[uvwFaces[i].t[1]];
				t[2] = uvwPoints[uvwFaces[i].t[2]];
	
				t[0].z = 0.0f;
				t[1].z = 0.0f;
				t[2].z = 0.0f;

				Point3 hitPoint;
				hitPoint.x = v;
				hitPoint.y = u;
				hitPoint.z = 0.0f;
				Point3 baryCoord = BaryCoords(t[0], t[1], t[2], hitPoint);

//check if inside a triangle
				if (!( (baryCoord.x<0.0f || baryCoord.x>1.0f || 
					    baryCoord.y<0.0f || baryCoord.y>1.0f || 
						baryCoord.z<0.0f || baryCoord.z>1.0f) ||
						(fabs(baryCoord.x + baryCoord.y + baryCoord.z - 1.0f) > EPSILON) ))
					{
					int cellID = x*width+y;
					if (!processedCells[cellID])
						{
						processedCells.Set(cellID,TRUE);
								//we are inside 
						Point3 wp = w[0] * baryCoord.x +
							 	 w[1] * baryCoord.y +
								 w[2] * baryCoord.z;

						worldSpaceList.Append(1,&wp,5000);

						uvwList.Append(1,&cellID,5000);
						}
					i = msh->numFaces;
					}

				}
//if hit add
//else look at the corners
			

			u += incU;
			}
		v += incV;

		}
		*/
	halfU = 1.0f/(float)width *0.5f;
	halfV = 1.0f/(float)height *0.5f;

	incU = 1.0f/(float)width;
	incV = 1.0f/(float)height;

//	float u,v;
//	v = halfV;

	for (i = 0; i < msh->numFaces; i++)
		{

		TSTR name;
		name.printf("Processing Face %d/%d",i,msh->numFaces-1);
		SetWindowText(textHWND,name);
		
//gets its world space position corners
		Point3 t[3];
		Point3 w[3];
		

		w[0] = tempWorldPointList[msh->faces[i].v[0]];
		w[1] = tempWorldPointList[msh->faces[i].v[1]];
		w[2] = tempWorldPointList[msh->faces[i].v[2]];


		t[0] = uvwPoints[uvwFaces[i].t[0]];
		t[1] = uvwPoints[uvwFaces[i].t[1]];
		t[2] = uvwPoints[uvwFaces[i].t[2]];
	
		t[0].z = 0.0f;
		t[1].z = 0.0f;
		t[2].z = 0.0f;

//scan it from bitmap space to world space
		int minX,maxX,minY,maxY;
		minX = floor(t[0].x*width);
		maxX = ceil(t[0].x*width);
		minY = floor(t[0].y*height);
		maxY = ceil(t[0].y*height);
		for (int j = 1; j < 3; j++)
			{
			int tempMinX, tempMaxX;
			int tempMinY, tempMaxY;
			tempMinX = floor(t[j].x*width);
			tempMaxX = ceil(t[j].x*width);
			tempMinY = floor(t[j].y*height);
			tempMaxY = ceil(t[j].y*height);

			if (tempMinX < minX) minX = tempMinX;
			if (tempMinY < minY) minY = tempMinY;

			if (tempMaxX > maxX) maxX = tempMaxX;
			if (tempMaxY > maxY) maxY = tempMaxY;

			}

		minY--;
		minX--;
		maxY++;
		maxX++;
		if (maxX >= width) maxX = width-1;
		if (maxY >= height) maxY = height-1;
		if (minX < 0) minX = 0;
		if (minY < 0) minY = 0;

		Box3 bounds;
		bounds.Init();
		
		bounds+=t[0];
		bounds+=t[1];
		bounds+=t[2];


//more ugliness below
		float baryMin = 0.0f;// - dist;//(20.0f/width);
		float baryMax = 1.0f;// + dist;//(20.0f/width);

		float u,v;
		v = (float)minY/(float)height + halfV;

		for (j =minY; j <= maxY; j++)
			{

			u = (float)minX/(float)width+halfU;

			for (int k =minX; k <= maxX; k++)
				{
				Point3 hitPoint;
//				hitPoint.x = (float)k/(float)width;
//				hitPoint.y = (float)j/(float)height;
				hitPoint.x = u;
				hitPoint.y = v;
				hitPoint.z = 0.0f;
				Point3 baryCoord = BaryCoords(t[0], t[1], t[2], hitPoint);
//check if inside a triangle
				if (!( (baryCoord.x<0.0f || baryCoord.x>1.0f || 
					    baryCoord.y<0.0f || baryCoord.y>1.0f || 
						baryCoord.z<0.0f || baryCoord.z>1.0f) ||
						(fabs(baryCoord.x + baryCoord.y + baryCoord.z - 1.0f) > EPSILON) ))
					{
					int cellID = j*width+k;
					if (!processedCells[cellID])
						{
						processedCells.Set(j*width+k,TRUE);
								//we are inside 
						Point3 wp = w[0] * baryCoord.x +
							 	 w[1] * baryCoord.y +
								 w[2] * baryCoord.z;

						worldSpaceList.Append(1,&wp,5000);

						uvwList.Append(1,&cellID,5000);
						}
					}
				else 
					{
//DebugPrint("missed point\n");
					}
				u += incU;
				}
			v += incV;
			}

		}

 	BitArray edges;

	edges.SetSize(width*height);
	edges.ClearAll();
	
	int overScan = 0;

	pblock->GetValue(pb_overscan,0,overScan, FOREVER);

	overScan++;

	for (int overs = 0; overs < overScan; overs++)
		{
		edges.ClearAll();
		for (i = 0; i < msh->numFaces; i++)
			{
	
			TSTR name;
			name.printf("Overscan %d Edges %d/%d",overs,i,msh->numFaces-1);
			SetWindowText(textHWND,name);
		
//gets its world space position corners
			Point3 t[3];
			Point3 w[3];
		

			w[0] = tempWorldPointList[msh->faces[i].v[0]];
			w[1] = tempWorldPointList[msh->faces[i].v[1]];
			w[2] = tempWorldPointList[msh->faces[i].v[2]];


			t[0] = uvwPoints[uvwFaces[i].t[0]];
			t[1] = uvwPoints[uvwFaces[i].t[1]];
			t[2] = uvwPoints[uvwFaces[i].t[2]];
	
			t[0].z = 0.0f;
			t[1].z = 0.0f;
			t[2].z = 0.0f;

//scan it from bitmap space to world space
			int minX,maxX,minY,maxY;
			minX = floor(t[0].x*width);
			maxX = ceil(t[0].x*width);
			minY = floor(t[0].y*height);
			maxY = ceil(t[0].y*height);
			for (int j = 1; j < 3; j++)
				{
				int tempMinX, tempMaxX;
				int tempMinY, tempMaxY;
				tempMinX = floor(t[j].x*width);
				tempMaxX = ceil(t[j].x*width);
				tempMinY = floor(t[j].y*height);
				tempMaxY = ceil(t[j].y*height);

				if (tempMinX < minX) minX = tempMinX;
				if (tempMinY < minY) minY = tempMinY;

				if (tempMaxX > maxX) maxX = tempMaxX;
				if (tempMaxY > maxY) maxY = tempMaxY;

				}

			minY-=(overs);
			minX-=(overs);
			maxY+=(overs);
			maxX+=(overs);;
			if (maxX >= width) maxX = width-1;
			if (maxY >= height) maxY = height-1;
			if (minX < 0) minX = 0;
			if (minY < 0) minY = 0;


			Box3 bounds;
			bounds.Init();
		
			bounds+=t[0];
			bounds+=t[1];
			bounds+=t[2];

			float boundsLength = Length(bounds.pmin-bounds.pmax);
			float dist = (boundsLength) * width;
			if (dist != 0.0f)
				dist = (dist + .50f)/dist;
//		dist = 0.0f;
//more ugliness below
			float baryMin = 0.0f;// - dist;//(20.0f/width);
			float baryMax = 1.0f;// + dist;//(20.0f/width);


//		float u,v;
//		v = (float)minY/(float)height + halfV;

			for (j =minY; j <= maxY; j++)
				{
				for (int k =minX; k <= maxX; k++)
					{
				
					int cellID = j*width+k;

					if (processedCells[cellID])
						{

						for (int m=0; m < 8; m++)
							{
							int kx,jy;
							kx = k;
							jy = j;
							if (m==0)
								{
								kx--;jy--;
								}
							else if (m==1)
								{
								jy--;
								}
							else if (m==2)
								{
								kx++;jy--;
								}
							else if (m==3)
								{
								kx--;
								}
							else if (m==4)
								{
								kx++;
								}
							else if (m==5)
								{
								kx--;jy++;
								}
							else if (m==6)
								{
								jy++;
								}
							else if (m==7)
								{
								kx++;jy++;
								}
							if (kx < 0) kx = 0;
							if (jy < 0) jy = 0;
							if (kx >= width) kx = width-1;
							if (jy >= height) jy = height-1;



							int neighborCellID = jy*width+kx;
							if ((!processedCells[neighborCellID]) && (!edges[neighborCellID]))
								{
								edges.Set(neighborCellID,TRUE);
								Point3 hitPoint;
								hitPoint.x = (float)kx/(float)width+ halfU;;
								hitPoint.y = (float)jy/(float)height+ halfV;;
								hitPoint.z = 0.0f;
								Point3 baryCoord = BaryCoords(t[0], t[1], t[2], hitPoint);
//check		if inside a triangle

	
//							processedCells.Set(j*width+k,TRUE);
									//we are inside 
								Point3 wp = w[0] * baryCoord.x +
									 	 w[1] * baryCoord.y +
										 w[2] * baryCoord.z;


								worldSpaceList.Append(1,&wp,5000);
								uvwList.Append(1,&neighborCellID,5000);
								}
							}
						}
					}
				}
			}
		processedCells |= edges;

		}

//	strList.SetCount(uvwList.Count());
//	float *addr = strList.Addr(0);
//	memset(addr,0,uvwList.Count()*sizeof(float));

	TSTR name;
	if (whichText == 0)
		name.printf("Total lores UVWs %d  ",worldSpaceList.Count());
	else name.printf("Total hires UVWs %d  ",worldSpaceList.Count());
	SetWindowText(textHWND,name);
	//FIX we can dump alot of this stuff for instance the worldSpace list
	//the uvwPoints and the UVW faces




}



void	PainterTextureSample::ShowMap()
{
	pblock->GetValue( pb_bitmap, 0,hiresBitmapPB, FOREVER );
	if ( (hiresBitmapPB) &&  (hiresBitmapPB->bm ) )
		{
		TSTR name(hiresBitmapPB->bi.Name());
		hiresBitmapPB->bm->Display(name);
		}

}

void	PainterTextureSample::SaveMap()
{

	pblock->GetValue( pb_bitmap, 0,hiresBitmapPB, FOREVER );
	if ( (hiresBitmapPB) &&  (hiresBitmapPB->bm ) )
		{
		hiresBitmapPB->bm->OpenOutput(&hiresBitmapPB->bi);
		hiresBitmapPB->bm->Write(&hiresBitmapPB->bi);
		hiresBitmapPB->bm->Close(&hiresBitmapPB->bi);
		}

}

void	PainterTextureSample::UpdateMap()
{
	pblock->GetValue( pb_bitmap, 0,hiresBitmapPB, FOREVER );
	if ( (hiresBitmapPB) &&  (hiresBitmapPB->bm ) )
		{
		hiresBitmapPB->bm->RefreshWindow();
		}
	
}


void	PainterTextureSample::CreateBitmap(int size)

{
	BitmapInfo bi;
	BOOL iret = TheManager->SelectFileOutput(&bi ,GetCOREInterface()->GetMAXHWnd() ,"Select File");
	if (iret)
		{
		bi.SetWidth(size);
		bi.SetHeight(size);
		bi.SetType(BMM_TRUE_64);
		Bitmap *map = TheManager->Create(&bi);

		map->OpenOutput(&bi);
		map->Write(&bi);
		map->Close(&bi);

		if (hiresBitmapPB == NULL)
			hiresBitmapPB = new PBBitmap(bi);
		hiresBitmapPB->bm = map;
		pblock->SetValue( pb_bitmap, 0,hiresBitmapPB );
		hiresWidth = hiresBitmapPB->bi.Width();
		hiresHeight = hiresBitmapPB->bi.Height();
		if ( (bm == NULL) && (width!=0))
			bm = BuildBitmap(width);
		}

}

INT_PTR CALLBACK SizeFloaterDlgProc(
		HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
	{
	PainterTextureSample *tex = (PainterTextureSample*)GetWindowLongPtr(hWnd,GWLP_USERDATA);
	//POINTS p = MAKEPOINTS(lParam);	commented out by sca 10/7/98 -- causing warning since unused.
	static ISpinnerControl *iSize = NULL;

	switch (msg) {
		case WM_INITDIALOG:

			{
			tex = (PainterTextureSample*)lParam;

			SetWindowLongPtr(hWnd,GWLP_USERDATA,lParam);


//create spinners and set value
			iSize = SetupIntSpinner(
				hWnd,IDC_SIZE2SPINNER,IDC_SIZE2,
				0,2048,512);	


			break;
			}


		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				case IDOK:
					{

					tex->CreateBitmap(iSize->GetIVal());
					ReleaseISpinner(iSize);
					iSize = NULL;
					
					

					EndDialog(hWnd,1);
					
					break;
					}
				case IDCANCEL:
					{
				
					ReleaseISpinner(iSize);
					iSize = NULL;

					EndDialog(hWnd,0);

					break;
					}


				}
			break;

		default:
			return FALSE;
		}
	return TRUE;
	}



Point3 *PainterTextureSample::InitMesh(Mesh *msh, Matrix3 tm, int &ct)
{
	//check if no bitmap
	pblock->GetValue( pb_bitmap, 0,hiresBitmapPB, FOREVER );
	if ( (hiresBitmapPB==NULL) ||  (hiresBitmapPB->bm == NULL ) )
		{
		DialogBoxParam(	hInstance,
							MAKEINTRESOURCE(IDD_SIZEDIALOG),
							GetCOREInterface()->GetMAXHWnd(),
							SizeFloaterDlgProc,
							(LPARAM)this );
		}
	//check if not in viewport
	if (width == 0)
		{
		int nodeCount =  GetCOREInterface()->GetSelNodeCount();
		if (nodeCount > 0)
			{
			node = GetCOREInterface()->GetSelNode(0);

			Mtl *mtl = node->GetMtl();
			GetCOREInterface()->ActivateTexture(this,mtl);
			
			}
		}


	int uvCount = msh->getNumMapVerts(1);
	int numFaces = msh->numFaces;
	uvwPoints.SetCount(uvCount);
	uvwFaces.SetCount(numFaces);

	if (uvCount == 0) return NULL;

	memcpy(uvwPoints.Addr(0), msh->mapVerts(1),uvCount*sizeof(Point3));
	memcpy(uvwFaces.Addr(0), msh->mapFaces(1),numFaces*sizeof(TVFace));

	
	BuildWorldSpaceData(msh,tm,
						width,width,
						loresWorldSpaceList,loresUVWIndexList,0);


	int lowct = loresWorldSpaceList.Count();

	if (lowct == 0) return NULL;

	BuildWorldSpaceData(msh,tm,
						hiresWidth,hiresHeight,
						hiresWorldSpaceList,hiresUVWIndexList,1);
//need a custom hook back here
	ct = hiresWorldSpaceList.Count();

	if (ct == 0) return NULL;

	hiresGatherer.BuildGatherData(50, hiresWorldSpaceList.Addr(0), ct);


//init color space
//FIX	colorData.SetCount(width * width);
	
	BMM_Color_64 tempBit;
	tempBit.r = 65535;
	tempBit.g = 65535;
	tempBit.b = 65535;
	tempBit.a = 0;



	ct = lowct;
	if (lowct == 0)
		return NULL;
	else return loresWorldSpaceList.Addr(0);


}



int PainterTextureSample::GetStrokeType()

{
pblock->GetValue(pb_stroketype,0,strokeType,FOREVER);
return strokeType;
}

int PainterTextureSample::GetSampleRate()

{
	int sampleRate;
	pblock->GetValue(pb_samplerate,0,sampleRate,FOREVER);
	return sampleRate;
}

int PainterTextureSample::GetGradient()

{
	int gradient;
	pblock->GetValue(pb_gradient,0,gradient,FOREVER);
	return gradient;
}

Texmap *PainterTextureSample::GetGradientTex()

{
	Texmap *gradientTex;
	pblock->GetValue(pb_gradienttex,0,gradientTex,FOREVER);
	return gradientTex;
}
		

INode *PainterTextureSample::GetNode()

{
	INode *node;
	pblock->GetValue(pb_spline,0,node,FOREVER);
	return node;
}

Point3 PainterTextureSample::GetStrokeColor()

{
	Point3 c;
	pblock->GetValue(pb_color,0,c,FOREVER);
	return c;
}


void* PainterTextureSample::GetInterface(ULONG id)

{
	switch(id)
	{
		case PAINTERCANVASINTERFACE_V5 : return (IPainterCanvasInterface_V5 *) this;
			break;
		default: return Texmap::GetInterface(id);
			break;
	}
}

BOOL  PainterTextureSample::SystemEndPaintSession()
{
	if (painterProc) painterProc->SystemEndPaintSession();
	return TRUE;
}


		

void  PainterTextureSample::HoldMap()
{
	if (!theHold.Holding()) 
		theHold.Begin();
	theHold.Put(new HoldMapRestore(this));

}