#include "PainterTextureSample.h"
#include "meshadj.h"

void PainterTextureSample::CleanUpEdges(INode *node, Bitmap *map, int channel, float blurRange)
{
	if (node == NULL) return;
	if (map == NULL) return;


	Mesh *msh = NULL;
	
	ObjectState sos;
	TimeValue t = GetCOREInterface()->GetTime();
	sos = node->EvalWorldState(t);
	TriObject *collapsedtobj = NULL;

	if (sos.obj)
		{
		if (sos.obj->IsSubClassOf(triObjectClassID))
			{
			TriObject *tobj = (TriObject*)sos.obj;
			msh = &tobj->GetMesh();
			}
//collapse it to a mesh
		else if (sos.obj->CanConvertToType(triObjectClassID))
			{
			collapsedtobj = (TriObject*) sos.obj->ConvertToType(t,triObjectClassID);
			msh = &collapsedtobj->GetMesh();
			}
		}
	if (msh == NULL) return;

//get TVFace data
//get uv data
	TVFace *tvFaces = NULL;
	tvFaces = msh->mapFaces(channel);
	if (tvFaces == NULL) return;

//get geom edges
	AdjEdgeList edges(*msh);

//loop through all the edges and look for edges that are shared but open
//	for (int i = 0; i < edges.edge.Count(); i++)
//		{

//		}
//build a matrix for each edge

	if (collapsedtobj) collapsedtobj->DeleteThis();
}